## dune 1.6.2

=== Makefile ===
PREFIX_ARG := $(if $(PREFIX),--prefix $(PREFIX),)
LIBDIR_ARG := $(if $(LIBDIR),--libdir $(LIBDIR),)
INSTALL_ARGS := $(PREFIX_ARG) $(LIBDIR_ARG)
BIN := ./_build/default/bin/main_dune.exe

-include Makefile.dev

default: boot.exe
	./boot.exe

release: boot.exe
	./boot.exe --release

boot.exe: bootstrap.ml
	ocaml bootstrap.ml

install:
	$(BIN) install $(INSTALL_ARGS) dune

uninstall:
	$(BIN) uninstall $(INSTALL_ARGS) dune

reinstall: uninstall reinstall

test:
	$(BIN) runtest

test-js:
	$(BIN) build @runtest-js

test-all:
	$(BIN) build @runtest @runtest-js

check:
	$(BIN) build @check

promote:
	$(BIN) promote

accept-corrections: promote

all-supported-ocaml-versions:
	$(BIN) build @install @runtest --workspace dune-workspace.dev --root .

clean:
	rm -f ./boot.exe $(wildcard ./bootstrap.cmi ./bootstrap.cmo ./bootstrap.exe)
	$(BIN) clean

distclean: clean
	rm -f src/setup.ml

doc:
	cd doc && sphinx-build . _build

livedoc:
	cd doc && sphinx-autobuild . _build \
	  -p 8888 -q  --host $(shell hostname) -r '\.#.*'

update-jbuilds: $(BIN)
	$(BIN) build @doc/runtest --auto-promote

# If the first argument is "run"...
ifeq (dune,$(firstword $(MAKECMDGOALS)))
  # use the rest as arguments for "run"
  RUN_ARGS := $(wordlist 2,$(words $(MAKECMDGOALS)),$(MAKECMDGOALS))
  # ...and turn them into do-nothing targets
  $(eval $(RUN_ARGS):;@:)
endif

dune: $(BIN)
	$(BIN) $(RUN_ARGS)

.PHONY: default install uninstall reinstall clean test doc
.PHONY: promote accept-corrections opam-release dune check

opam-release:
	dune-release distrib --skip-build --skip-lint --skip-tests
	dune-release publish distrib --verbose
	dune-release opam pkg
	dune-release opam submit

## dune 1.0~beta20

=== debian/changelog ===
dune (1.0~beta20-1) unstable; urgency=medium

  * Team upload
  * New upstream version (2018-04-10)
    + Fix FTBFS on bytecode-only archs (Closes: #894088)
  * debian/rules: Keep libdir to /usr/lib/ocaml (Closes: #894545)
  * Bump Standards-Version to 4.1.4.
    No change required.
  * Switch to debhelper 11
  * Package transition to “Dune” (Closes: #896466)
    Upstream renamed the project

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Sat, 21 Apr 2018 12:59:57 +0200

jbuilder (1.0~beta19-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    + Updated d/rules to call ./configure manually because it errors
      on extra arguments

 -- Andy Li <andy@onthewings.net>  Mon, 19 Mar 2018 15:21:27 +0800

jbuilder (1.0~beta18-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    * Fix library builds on OCaml bytecode-only architectures
      (Closes: #881770)
  * Update d/jbuilder.opam-install and d/jbuilder.manpages
  * Bump Standards-Version to 4.1.3 (no changes)

 -- Andy Li <andy@onthewings.net>  Wed, 28 Feb 2018 16:36:09 +0800

jbuilder (1.0~beta14-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Thu, 12 Oct 2017 10:18:46 +0200

jbuilder (1.0~beta11-1) unstable; urgency=medium

  * Initial release (Closes: #870130)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 30 Jul 2017 10:53:53 +0200

=== debian/control ===
Source: dune
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>
Build-Depends:
 ocaml-nox,
 ocaml-findlib,
 dh-ocaml,
 debhelper (>= 11)
Standards-Version: 4.1.4
Homepage: https://github.com/janestreet/jbuilder
Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/jbuilder.git
Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/jbuilder.git

Package: dune
Architecture: any
Breaks: jbuilder (<< 1.0~beta20-1)
Replaces: jbuilder (<< 1.0~beta20-1)
Provides: jbuilder
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Description: composable build system for OCaml projects
 Dune is a build system designed for OCaml/Reason projects
 only. It focuses on providing the user with a consistent experience
 and takes care of most of the low-level details of OCaml
 compilation. All you have to do is provide a description of your
 project and Dune will do the rest.

Package: jbuilder
Architecture: all
Depends: dune
Description: composable build system for OCaml projects -- transitional package
 Dune is a build system designed for OCaml/Reason projects
 only. It focuses on providing the user with a consistent experience
 and takes care of most of the low-level details of OCaml
 compilation. All you have to do is provide a description of your
 project and Dune will do the rest.
 .
 Dune was previously called jbuilder; this is a transitional package,
 which can be safely removed.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

DESTDIR=$(CURDIR)/debian/dune

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	./configure --libdir /usr/lib/ocaml

.PHONY: override_dh_auto_build
override_dh_auto_build:
	ocaml bootstrap.ml
	./boot.exe

.PHONY: override_dh_auto_install
override_dh_auto_install:
# Check that installed files have not changed. If so, the Debian
# packaging must be adapted by hand. This way, we avoid a dependency
# on opam-installer.
	diff -u debian/jbuilder.opam-install jbuilder.install

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	rm -rf _build */.merlin vendor/*/*/.merlin boot.exe jbuilder.install

.PHONY: override_dh_install
override_dh_install:
# We don't use dh_install nor dh_installdocs because they don't handle
# symbolic links nor renaming files
	mkdir -p $(DESTDIR)/usr/bin
	cp _build/install/default/bin/jbuilder $(DESTDIR)/usr/bin
	mkdir -p $(DESTDIR)/usr/share/doc/dune
	cp _build/install/default/doc/jbuilder/README.md $(DESTDIR)/usr/share/doc/dune

=== debian/watch ===
version=3
opts=uversionmangle=s/\.beta/~beta/,filenamemangle=s/jbuilder/dune/ \
https://github.com/janestreet/jbuilder/releases .*/jbuilder-(.*)\.tbz

## dune 1.6.2

=== debian/changelog ===
dune (1.6.2-2) unstable; urgency=medium

  * Add Breaks+Replaces: whitedune (<< 0.30.10-2.2) (Closes: #919622)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 18 Jan 2019 17:50:45 +0100

dune (1.6.2-1) unstable; urgency=medium

  * New upstream release
    - add new binary package libdune-ocaml-dev
  * Update debian/watch
  * Update Vcs-*
  * Bump Standards-Version to 4.2.1 (no changes)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 08 Dec 2018 15:27:49 +0100

=== debian/control ===
--- 
+++ 
@@ -8,15 +8,15 @@
  ocaml-findlib,
  dh-ocaml,
  debhelper (>= 11)
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Homepage: https://github.com/janestreet/jbuilder
-Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/jbuilder.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/jbuilder.git
+Vcs-Git: https://salsa.debian.org/ocaml-team/jbuilder.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/jbuilder
 
 Package: dune
 Architecture: any
-Breaks: jbuilder (<< 1.0~beta20-1)
-Replaces: jbuilder (<< 1.0~beta20-1)
+Breaks: jbuilder (<< 1.0~beta20-1), whitedune (<< 0.30.10-2.2)
+Replaces: jbuilder (<< 1.0~beta20-1), whitedune (<< 0.30.10-2.2)
 Provides: jbuilder
 Depends:
  ${ocaml:Depends},
@@ -29,9 +29,26 @@
  compilation. All you have to do is provide a description of your
  project and Dune will do the rest.
 
+Package: libdune-ocaml-dev
+Architecture: any
+Depends:
+ ${ocaml:Depends},
+ ${shlibs:Depends},
+ ${misc:Depends}
+Suggests:
+ ocaml-findlib
+Description: composable build system for OCaml projects (library)
+ Dune is a build system designed for OCaml/Reason projects
+ only. It focuses on providing the user with a consistent experience
+ and takes care of most of the low-level details of OCaml
+ compilation. All you have to do is provide a description of your
+ project and Dune will do the rest.
+ .
+ This package contains the library.
+
 Package: jbuilder
 Architecture: all
-Depends: dune
+Depends: dune, ${misc:Depends}
 Description: composable build system for OCaml projects -- transitional package
  Dune is a build system designed for OCaml/Reason projects
  only. It focuses on providing the user with a consistent experience

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	./configure --libdir /usr/lib/ocaml

.PHONY: override_dh_auto_build
override_dh_auto_build:
	ocaml bootstrap.ml
	./boot.exe

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	rm -rf _build boot.exe src/setup.ml dune.install
	find -name .merlin -delete

.PHONY: override_dh_auto_test
override_dh_auto_test:
# Upstream tests assume opam is installed; skip them

.PHONY: override_dh_missing
override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=3
opts=uversionmangle=s/\.beta/~beta/ \
https://github.com/ocaml/dune/releases .*/dune-(.*)\.tbz

## dune alugrid-2.11.0.0

=== CMakeLists.txt ===
# general stuff
cmake_minimum_required(VERSION 3.16)

# set up project
project("dune-alugrid" C CXX)

#circumvent not building docs
set(BUILD_DOCS 1)
set(DUNE_REENABLE_ADD_TEST TRUE)

# Set the default DUNE_MAX_TEST_CORES that is used in the parallel tests
if(NOT DUNE_MAX_TEST_CORES)
  set(DUNE_MAX_TEST_CORES 4)
endif()

# grid selector in separate file to avoid excessive dependencies
set(ALUGRID_EXTRA_GRIDSELECTOR_FILE TRUE)

option(ALUGRID_DISABLE_METIS "Disable METIS as partitioner" TRUE)
if(ALUGRID_DISABLE_METIS)
  set(CMAKE_DISABLE_FIND_PACKAGE_METIS TRUE)
endif()

# set to true to compile more things into library
set(DUNE_ALUGRID_COMPILE_BINDINGS FALSE)

# variable to be set in config.h
if( DUNE_ALUGRID_COMPILE_BINDINGS )
  set(DUNE_ALUGRID_COMPILE_BINDINGS_IN_LIB 1)
endif()

# guess dune-common build dir
if(NOT (dune-common_DIR OR dune-common_ROOT OR
        "${CMAKE_PREFIX_PATH}" MATCHES ".*dune-common.*"))
    string(REPLACE ${CMAKE_PROJECT_NAME} dune-common dune-common_DIR
      ${PROJECT_BINARY_DIR})
endif()

#find dune-common and set the module path
find_package(dune-common REQUIRED)

list(APPEND CMAKE_MODULE_PATH ${dune-common_MODULE_PATH}
  "${PROJECT_SOURCE_DIR}/cmake/modules")

#include the dune macros
include(DuneMacros)

# deactivate global include-directories
dune_policy(SET DP_DEFAULT_INCLUDE_DIRS NEW)

# deactivate global calls to add_dune_all_flags in tests
dune_policy(SET DP_TEST_ADD_ALL_FLAGS NEW)

# do not make suggested dependencies required automatically
dune_policy(SET DP_SUGGESTED_MODULE_DEPENDENCIES_REQUIRED_DOWNSTREAM NEW)

# start a dune project with information from dune.module
dune_project()

# Define the dune-alugrid library
dune_add_library(dunealugrid EXPORT_NAME ALUGrid NAMESPACE Dune::)
target_link_libraries(dunealugrid PUBLIC Dune::Grid)
dune_default_include_directories(dunealugrid PUBLIC)

add_subdirectory(cmake/modules)

add_subdirectory(doc/doxygen)

add_subdirectory(dune)
add_subdirectory(lib)

if(EXISTS "${PROJECT_SOURCE_DIR}/examples")
  add_subdirectory(examples EXCLUDE_FROM_ALL)
endif()
add_subdirectory(utils)

# if Python bindings are enabled, include necessary sub directories.
if( DUNE_ENABLE_PYTHONBINDINGS )
  add_subdirectory("python")
endif()

#look for testgrids.hh header in dune-grid doc sub directory
find_path(DUNE_TESTGRIDS_INCLUDE_DIR testgrids.hh
  PATHS ${dune-grid_INCLUDE_DIRS}/doc/grids/gridfactory
  NO_DEFAULT_PATH
)

if(DUNE_TESTGRIDS_INCLUDE_DIR)
  set(HAVE_DUNE_GRID_TESTGRIDS 1)
endif()

# finalize the dune project, e.g., generate config.h etc.
finalize_dune_project()

=== lib/CMakeLists.txt ===
# configure the library dune-alugrid
if( DUNE_ALUGRID_COMPILE_BINDINGS )
  target_compile_options(dunealugrid PRIVATE -include${CMAKE_BINARY_DIR}/config.h)
endif()

# add mpi flags to compile library
add_dune_mpi_flags( dunealugrid )

# link against the Dune libraries
target_link_libraries(dunealugrid PUBLIC ${DUNE_LIBS})

include(AddMETISFlags)
# METIS dependencies
if(NOT ALUGRID_DISABLE_METIS)
  add_dune_metis_flags(dunealugrid)

  # Indicate that METIS is linked into dune-alugrid
  set(ALUGRID_HAVE_METIS TRUE)
endif()

# zoltan dependencies
if(ZOLTAN_FOUND)
  target_link_libraries(dunealugrid PUBLIC ${ZOLTAN_LIBRARIES})
  set_property(TARGET dunealugrid APPEND PROPERTY
               INCLUDE_DIRECTORIES "${ZOLTAN_INCLUDE_DIRS}")
endif()
# zlib dependencies
if(ZLIB_FOUND)
  target_link_libraries(dunealugrid PUBLIC ${ZLIB_LIBRARIES})
  set_property(TARGET dunealugrid APPEND PROPERTY
               INCLUDE_DIRECTORIES "${ZLIB_INCLUDE_DIR}")
endif()

# workaround for clang 6, which runs into an infinite loop on gitter_mgb.cc and gitter_pll_mgb.cc
# when optimization level is -O2 or higher
if(${CMAKE_CXX_COMPILER_ID} STREQUAL Clang AND ${CMAKE_CXX_COMPILER_VERSION} VERSION_GREATER 5.9.9 AND ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 7.0.0)
  string(TOUPPER "${CMAKE_BUILD_TYPE}" _build_type_upper)
  set(_flags "${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${_build_type_upper}}")
  string(REGEX MATCH " -O(2|3|fast) " _opt_level ${_flags})
  if (NOT _opt_level STREQUAL "")
    message(STATUS "detected clang 6 and optimized build: overriding optimization level for gitter_mgb.cc and gitter_pll_mgb.cc")
    set_source_files_properties(
      ../dune/alugrid/impl/serial/gitter_mgb.cc
      ../dune/alugrid/impl/parallel/gitter_pll_mgb.cc
      PROPERTIES
        COMPILE_FLAGS -O1
      )
    endif()
endif()

####################################################################
#### general warning: avoid such and similar commands here
#### as they will not influence anything after the library
#### is build!!! (as long as you do not call the export() function
#add_dune_zlib_flags(dunealugrid)
#####################################################################

install(FILES dunealugridam2cmake.lib
  DESTINATION ${CMAKE_INSTALL_BINDIR}/../lib)

=== python/CMakeLists.txt ===
add_subdirectory(dune)

dune_python_configure_bindings(
  PATH "."
  CMAKE_METADATA_FLAGS DUNE_OPTS_FILE
)

=== dune/alugrid/impl/serial/CMakeLists.txt ===
set(serialdir  ${CMAKE_INSTALL_INCLUDEDIR}/dune/alugrid/impl/serial)
set(serial_HEADERS  gatherscatter.hh ghost_elements.h ghost_info.h
                 gitter_hexa_top.h gitter_impl.h gitter_mgb.h gitter_sti.h
                 gitter_tetra_top.h iterator_sti.h key.h mapp_cube_3d.h
                 mapp_tetra_3d_ext.h mapp_tetra_3d.h myalloc.h parallel.h
                 refcount.hh refinementrules.h serialize.h walk.h)
set(EXTRA_DIST  ghost_elements.cc ghost_info.cc gitter_geo.cc gitter_hexa_top.cc
             gitter_impl.cc gitter_mgb.cc gitter_sti.cc gitter_tetra_top.cc
             mapp_cube_3d.cc mapp_tetra_3d.cc myalloc.cc)
# include not needed for CMake
# include $(top_srcdir)/am/global-rules
install(FILES ${serial_HEADERS} DESTINATION ${serialdir})

## dune alugrid-2.11.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -59,6 +59,7 @@
 
 # Define the dune-alugrid library
 dune_add_library(dunealugrid EXPORT_NAME ALUGrid NAMESPACE Dune::)
+dune_enable_all_packages()
 target_link_libraries(dunealugrid PUBLIC Dune::Grid)
 dune_default_include_directories(dunealugrid PUBLIC)

=== examples/CMakeLists.txt ===
add_subdirectory(backuprestore)
add_subdirectory(callback)
add_subdirectory(communication)
add_subdirectory(dgf)
add_subdirectory(loadbalance)
add_subdirectory(quality)
add_subdirectory(testEfficiency)

set(DEFAULT_GRID_TYPE ALUGRID_CUBE)

set(examplesdir  ${CMAKE_INSTALL_INCLUDEDIR}/examples)
set(examples_HEADERS adaptation.hh
                     diagnostics.hh
                     paralleldgf.hh
                     problem-ball.hh
                     problem-transport.hh
                     datamap.hh
                     fvscheme.hh
                     piecewisefunction.hh
                     problem-euler.hh
                     problem.hh)

configure_file(alugrid.cfg ${CMAKE_CURRENT_BINARY_DIR}/alugrid.cfg COPYONLY)

# enable all flags and link against alugrid library
link_libraries(Dune::ALUGrid)
dune_enable_all_packages()

foreach(variant ball euler transport)
  string(TOUPPER ${variant} variant_upper)
  add_executable(main_${variant} main.cc )
  target_compile_definitions(main_${variant} PRIVATE ${variant_upper})
  if("${variant}" STREQUAL "ball")
    target_compile_definitions(main_${variant} PRIVATE "ALUGRID_COUNT_GLOBALCOMM")
  endif()
  target_compile_definitions(main_${variant} PUBLIC "${DEFAULT_GRID_TYPE}" "GRIDDIM=2" "WORLDDIM=2" "USE_ALUGRID_SFC_ORDERING")

  foreach(type cube simplex conform)
    string(TOUPPER ${type} type_upper)
    foreach(dim RANGE 2 3)
      add_executable(main_${variant}_${type}_${dim}d EXCLUDE_FROM_ALL main.cc)
      target_compile_definitions(main_${variant}_${type}_${dim}d PRIVATE "${variant_upper}" "ALUGRID_${type_upper}" "GRIDDIM=${dim}" "WORLDDIM=${dim}")
    endforeach()
  endforeach()
endforeach()

install(FILES ${examples_HEADERS} DESTINATION ${examplesdir})

=== cmake/modules/CMakeLists.txt ===
set(modules
    CMakeLists.txt
    DuneAlugridMacros.cmake
    FindDLMalloc.cmake
    FindPThreads.cmake
    FindSIONLib.cmake
    FindZOLTAN.cmake
    AlugridTortureTests.cmake
)
install(FILES ${modules} DESTINATION ${DUNE_INSTALL_MODULEDIR})

=== examples/callback/CMakeLists.txt ===
set(callbackdir  ${CMAKE_INSTALL_INCLUDEDIR}/examples/callback)
set(callback_HEADERS adaptation.hh
                          diagnostics.hh
                          paralleldgf.hh
                          problem-ball.hh
                          problem-transport.hh
                          datamap.hh
                          fvscheme.hh
                          piecewisefunction.hh
                          problem-euler.hh
                          problem.hh)

add_definitions("-DALUGRID_CUBE")
add_definitions("-DUSE_ALUGRID_SFC_ORDERING")

#add_definitions("-DUSE_VECTOR_FOR_PWF")

configure_file(check-adaptation.sh ${CMAKE_CURRENT_BINARY_DIR}/check-adaptation.sh COPYONLY)

foreach(variant transport ball euler)
  foreach( DIM 2 3 )
    string(TOUPPER ${variant} variant_upper)
    add_executable(main_${variant}_cb_${DIM}d main.cc)
    dune_target_enable_all_packages(main_${variant}_cb_${DIM}d)
    target_compile_definitions(main_${variant}_cb_${DIM}d PRIVATE "${variant_upper}" "GRIDDIM=${DIM}" "CALLBACK_ADAPTATION")
    set_property(TARGET main_${variant}_cb_${DIM}d APPEND PROPERTY LINK_LIBRARIES dunealugrid)
  endforeach()
endforeach()

install(FILES ${callback_HEADERS} DESTINATION ${callbackdir})

=== examples/quality/CMakeLists.txt ===
set(qualitydir  ${CMAKE_INSTALL_INCLUDEDIR}/examples/quality)

configure_file(alugrid.cfg ${CMAKE_CURRENT_BINARY_DIR}/alugrid.cfg COPYONLY)

foreach(variant quality)
  string(TOUPPER ${variant} variant_upper)
  add_executable(main_${variant} main.cc )
  dune_target_enable_all_packages(main_${variant})
  set_property(TARGET main_${variant} APPEND PROPERTY LINK_LIBRARIES dunealugrid)
  target_compile_definitions(main_${variant} PRIVATE ${variant_upper})
  target_compile_definitions(main_${variant} PRIVATE "ALUGRID_COUNT_GLOBALCOMM")
  target_compile_definitions(main_${variant} PUBLIC "ALUGRID_CONFORM" "GRIDDIM=3" "WORLDDIM=3")
endforeach()

add_executable(gmshtodgf gmshtodgf.cc )
dune_target_enable_all_packages(gmshtodgf)
set_property(TARGET gmshtodgf APPEND PROPERTY LINK_LIBRARIES dunealugrid)
target_compile_definitions(gmshtodgf PUBLIC "ALUGRID_SIMPLEX" "GRIDDIM=3" "WORLDDIM=3")

add_executable(estclo estimate-closure.cc)
dune_target_enable_all_packages(estclo)
set_property(TARGET estclo APPEND PROPERTY LINK_LIBRARIES dunealugrid)
target_compile_definitions(estclo PUBLIC "ALUGRID_CONFORM" "GRIDDIM=3" "WORLDDIM=3")

install(FILES ${examples_HEADERS} DESTINATION ${examplesdir})

=== dune/alugrid/test/CMakeLists.txt ===
set(TESTS
  test-alugrid
  test-structuredgridfactory
  test-backup-restore
  test-dgf
)

set(EXTRA_TESTS
  test-adaptivity
  test-fromtogridfactory
  test-periodic
  test-iterators
  test-twists
  test-hierarchic
  test-ball-projection
  test-gmsh
)

# enable all flags and link against alugrid library
link_libraries(Dune::ALUGrid)
dune_enable_all_packages()

foreach(TEST ${TESTS})
  dune_add_test(NAME ${TEST} SOURCES ${TEST}.cc MPI_RANKS 1 2 3 4 TIMEOUT 3600)
endforeach()

# the extra tests are only enabled in torture mode
if(ALUGRID_TORTURE_TESTS)
  foreach(TEST ${EXTRA_TESTS})
    dune_add_test(NAME ${TEST} SOURCES ${TEST}.cc)
  endforeach()
endif()

add_subdirectory(dgf)
add_subdirectory(gmsh)

set(alutestdir ${CMAKE_INSTALL_INCLUDEDIR}/dune/alugrid/test)
set(alugridtest_HEADERS checkintersectionit.hh  checktwists.hh  insertgrid.hh )

install( FILES ${alugridtest_HEADERS} DESTINATION ${alutestdir} )

=== python/dune/alugrid/CMakeLists.txt ===
add_python_targets(alugrid
  __init__
  _grids
)

# link against alugrid library and enable all package flags
link_libraries(Dune::ALUGrid)
dune_enable_all_packages()

dune_add_pybind11_module(NAME _alugrid SOURCES _alugrid.cc)

if( DUNE_ENABLE_PYTHONMODULE_PRECOMPILE )
  set(DIMS 2 3)
  set(GEOMTYPES simplex cube)
  foreach( DIM ${DIMS} )
    foreach( GT ${GEOMTYPES} )
      add_library(alugrid_${GT}_${DIM} OBJECT registeralugrid.cc)
      target_compile_definitions(alugrid_${GT}_${DIM} PRIVATE DIM=${DIM} GEOMTYPE=Dune::${GT})
      target_link_libraries(_alugrid PRIVATE alugrid_${GT}_${DIM})
    endforeach()
  endforeach()
endif()

if(SKBUILD)
  install(TARGETS _alugrid LIBRARY DESTINATION python/dune/alugrid)
endif()

=== dune/alugrid/test/dgf/CMakeLists.txt ===
set(DGFS
  2-3-testgrid.dgf
  ball.dgf
  cube-testgrid-2-2.dgf
  cube-testgrid-2-3.dgf
  another-testgrid-2-3.dgf
  grid2d_str1d.dgf
  periodic2.dgf
  periodic3.dgf
  sphere.dgf
  simplex-testgrid-2-2.dgf
  simplex-testgrid-2-3.dgf
  simplex-testgrid-2-3-noproj.dgf
  simplex-testgrid-3-3.dgf
)

foreach(dgf ${DGFS})
  configure_file( ${dgf} ${CMAKE_CURRENT_BINARY_DIR}/ COPYONLY)
endforeach()

install(FILES ${DGFS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/alugrid/test/dgf)

## dune client-0.2.2b0

=== Makefile ===
VENV = venv
PYTHON = $(VENV)/bin/python3
PIP = $(VENV)/bin/pip


$(VENV)/bin/activate: requirements/dev.txt
	python3 -m venv $(VENV)
	$(PIP) install --upgrade pip
	$(PIP) install -r requirements/dev.txt


install:
	make $(VENV)/bin/activate

clean:
	rm -rf __pycache__

fmt:
	black ./

lint:
	pylint dune_client/

types:
	mypy dune_client/ --strict

check:
	make fmt
	make lint
	make types

test-unit:
	python -m pytest tests/unit

test-e2e:
	python -m pytest tests/e2e

test-all:
	make test-unit
	make test-e2e

## dune client-1.10.0

=== Makefile ===
VENV = .venv
PYTHON = $(VENV)/bin/python3

# Install dependencies using uv
install:
	uv sync --no-dev

# Install with dev dependencies
install-dev:
	uv sync --dev

clean:
	rm -rf __pycache__ .tox dist

fmt:
	uv run ruff format

fmt-check:
	uv run ruff format --check

lint:
	uv run ruff check

lint-fix:
	uv run ruff check --fix

types:
	uv run mypy dune_client/ --strict

check: fmt lint types

test-unit:
	uv run python -m pytest tests/unit

test-e2e:
	uv run python -m pytest tests/e2e

test-all: test-unit test-e2e

test-tox:
	uv run tox

## dune geometry-2.11.0.2

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright © DUNE Project contributors, see file LICENSE.md in module root
# SPDX-License-Identifier: LicenseRef-GPL-2.0-only-with-DUNE-exception

cmake_minimum_required(VERSION 3.16)
project("dune-geometry" C CXX)

if(NOT (dune-common_DIR OR dune-common_ROOT OR
        "${CMAKE_PREFIX_PATH}" MATCHES ".*dune-common.*"))
    string(REPLACE  ${PROJECT_NAME} dune-common dune-common_DIR
      ${PROJECT_BINARY_DIR})
endif()

#find dune-common and set the module path
find_package(dune-common REQUIRED)
list(APPEND CMAKE_MODULE_PATH ${dune-common_MODULE_PATH})

#include the dune macros
include(DuneMacros)

# deactivate global include-directories
dune_policy(SET DP_DEFAULT_INCLUDE_DIRS NEW)

# do not make all suggested dependencies required automatically
dune_policy(SET DP_SUGGESTED_MODULE_DEPENDENCIES_REQUIRED_DOWNSTREAM NEW)

# start a dune project with information from dune.module
dune_project()

dune_add_library(dunegeometry EXPORT_NAME Geometry)
target_link_libraries(dunegeometry PUBLIC Dune::Common)

# set include directories to target
dune_default_include_directories(dunegeometry PUBLIC)

add_subdirectory("dune")
add_subdirectory("doc")

# if Python bindings are enabled, include necessary sub directories.
if( DUNE_ENABLE_PYTHONBINDINGS )
  add_subdirectory("python")
endif()

# finalize the dune project, e.g. generating config.h etc.
finalize_dune_project()

## dune polygongrid-2.11.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(dune-polygongrid CXX)

find_package(dune-common)
list(APPEND CMAKE_MODULE_PATH ${dune-common_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules")

include(DuneMacros)
dune_project()

add_subdirectory(cmake/modules)
add_subdirectory(dune)
add_subdirectory(test)

# if Python bindings are enabled, include necessary sub directories.
if( DUNE_ENABLE_PYTHONBINDINGS )
  add_subdirectory(python)
endif()

finalize_dune_project(GENERATE_CONFIG_H_CMAKE)

## dune spgrid-2.11.dev20250927

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project("dune-spgrid" C CXX)

find_package(dune-common)
list(APPEND CMAKE_MODULE_PATH ${dune-common_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake/modules")

include(DuneMacros)

# deactivate global include-directories
dune_policy(SET DP_DEFAULT_INCLUDE_DIRS NEW)

# deactivate global calls to add_dune_all_flags in tests
dune_policy(SET DP_TEST_ADD_ALL_FLAGS NEW)

# do not make suggested dependencies required automatically
dune_policy(SET DP_SUGGESTED_MODULE_DEPENDENCIES_REQUIRED_DOWNSTREAM NEW)

# start a dune project with information from dune.module
dune_project()

dune_add_library(dunespgrid INTERFACE
  EXPORT_NAME SPGrid
  LINK_LIBRARIES Dune::Grid)

dune_default_include_directories(dunespgrid INTERFACE)
link_libraries(Dune::SPGrid)

#target_link_libraries(dunespgrid INTERFACE Dune::Grid)


add_subdirectory(cmake/modules)
add_subdirectory(doc)
add_subdirectory(dune)

# if Python bindings are enabled, include necessary sub directories.
if( DUNE_ENABLE_PYTHONBINDINGS )
  add_subdirectory(python)
endif()

finalize_dune_project()

=== python/dune/spgrid/CMakeLists.txt ===
add_python_targets(spgrid
  __init__
)

dune_add_pybind11_module(NAME _spgrid SOURCES _spgrid.cc)
if( DUNE_ENABLE_PYTHONMODULE_PRECOMPILE )
  set(DIMS 1 2 3 4)
  foreach( DIM ${DIMS} )
    add_library(spgrid_${DIM} OBJECT registergrid.cc)
    target_compile_definitions(spgrid_${DIM} PRIVATE DIM=${DIM})
    dune_target_enable_all_packages( spgrid_${DIM} )

    target_link_libraries(_spgrid PRIVATE spgrid_${DIM})
  endforeach()
endif()

if(SKBUILD)
  install(TARGETS _spgrid LIBRARY DESTINATION python/dune/spgrid)
endif()

## dune vem-2.11.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(dune-vem CXX C)

#find dune-common and set the module path
find_package(dune-common)
list(APPEND CMAKE_MODULE_PATH ${dune-common_MODULE_PATH}
     "${CMAKE_SOURCE_DIR}/cmake/modules")# make sure our own modules are found

#include the dune macros
include(DuneMacros)

# deactivate global include-directories
dune_policy(SET DP_DEFAULT_INCLUDE_DIRS NEW)

# do not make suggested dependencies required automatically
dune_policy(SET DP_SUGGESTED_MODULE_DEPENDENCIES_REQUIRED_DOWNSTREAM NEW)

# start a dune project with information from dune.module
dune_project()

# add all package flags to all executables in all subdirs
dune_enable_all_packages()

include(AddMPIFlags)

add_subdirectory("dune")
add_subdirectory("cmake/modules")
add_subdirectory("pydemo")
add_subdirectory("python")

# create library target and export it as Dune::Vem
dune_add_library(dunevem INTERFACE
  EXPORT_NAME Vem
  LINK_LIBRARIES ${DUNE_LIBS})

# finalize the dune project, e.g. generating config.h etc.
finalize_dune_project(GENERATE_CONFIG_H_CMAKE)

=== lib/CMakeLists.txt ===
# dune_add_library(dunevem
#     _DUNE_TARGET_OBJECTS:io_
#   ADD_LIBS dunefem)

# install(FILES DESTINATION ${CMAKE_INSTALL_BINDIR}/../lib)

=== pydemo/CMakeLists.txt ===
dune_python_add_test(NAME pyhktest
                     SCRIPT hktest.py
                     WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                     LABELS quick)
dune_symlink_to_source_files(FILES hktest.py concave.py)

=== data/gmsh/CMakeLists.txt ===
set( GRIDFILES
  unit_sq_4x4_npart=4.msh
  unit_sq_8x8_npart=16.msh
  unit_sq_8x8_npart=2.msh
  unit_sq_8x8_npart=4.msh
  unitsq-tria-unstr_npart=16.msh
)

foreach( gridfile ${GRIDFILES} )
  configure_file( ${gridfile} ${CMAKE_CURRENT_BINARY_DIR}/${gridfile} COPYONLY )
endforeach()

=== dune/vem/CMakeLists.txt ===
add_subdirectory( agglomeration )
add_subdirectory( function )
add_subdirectory( misc )
add_subdirectory( operator )
add_subdirectory( space )
add_subdirectory( py )
add_subdirectory( test )

=== notMaintained/helmholtz-test/CMakeLists.txt ===
add_executable( fem-helmholtz EXCLUDE_FROM_ALL fem-helmholtz.cc )
target_link_libraries(fem-helmholtz )
add_executable( vem-helmholtz EXCLUDE_FROM_ALL vem-helmholtz.cc )
target_link_libraries( vem-helmholtz )

=== notMaintained/nonlinear-test/CMakeLists.txt ===
add_subdirectory( data )
add_executable( fem-nonlinear EXCLUDE_FROM_ALL fem-nonlinear.cc )
target_link_libraries(fem-nonlinear dunevem )
add_executable( vem-nonlinear EXCLUDE_FROM_ALL vem-nonlinear.cc )
target_link_libraries( vem-nonlinear dunevem )
add_executable( vem-nonlinear-istl EXCLUDE_FROM_ALL vem-nonlinear.cc )
target_compile_definitions( vem-nonlinear-istl PUBLIC WANT_ISTL=1 )
target_link_libraries( vem-nonlinear-istl dunevem )

=== notMaintained/poisson-test/CMakeLists.txt ===
add_subdirectory( data )
add_subdirectory( agglomeration-DG )
add_subdirectory( vem-test )

add_executable( dune-poisson-agglo-DG EXCLUDE_FROM_ALL dune-poisson-agglo-DG.cc )
target_link_libraries( dune-poisson-agglo-DG dunevem )
target_link_dune_default_libraries( dune-poisson-agglo-DG )

add_executable( trivial-agglomeration EXCLUDE_FROM_ALL trivial-agglomeration.cc )
target_link_libraries( trivial-agglomeration dunevem )
target_link_dune_default_libraries( trivial-agglomeration )

=== dune/vem/operator/CMakeLists.txt ===
set(HEADERS
  diffusionmodel.hh
  mass.hh
  stabmatrix.hh
  vemdirichletconstraints.hh
  vemelliptic.hh
)

install(FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/vem/operator)

=== dune/vem/py/CMakeLists.txt ===
install(FILES
  integrands.hh
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/vem/py
)

=== dune/vem/space/CMakeLists.txt ===
set(HEADERS
  basisfunctionset.hh
  curlfree.hh
  default.hh
  divfree.hh
  indexset.hh
  interpolate.hh
  interpolation.hh
  hk.hh
  test.hh
)

install(FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/vem/space)

=== dune/vem/test/CMakeLists.txt ===
set( SCRIPTS curlfree          divfree
             hk_laplace        perturbation
             varyingcoeff      uzawa )
add_python_targets(testscripts ${SCRIPTS})
foreach( script ${SCRIPTS} )
  dune_python_add_test(NAME ${script}
                       SCRIPT ${script}.py
                       WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                       LABELS quick)
endforeach()

if( ${FEM_TORTURE_TESTS} )
  set( SCRIPTS_TORTURE hk uzawa )
  add_python_targets(testscripts ${SCRIPTS_TORTURE})
  foreach( script ${SCRIPTS_TORTURE} )
    dune_python_add_test(NAME torture_${script}
                         SCRIPT ${script}.py
                         WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
  endforeach()
endif()
